package com.yunfeiyun.agmp.fms.domain.resvo;


import com.yunfeiyun.agmp.common.core.domain.BaseEntity;
import com.yunfeiyun.agmp.common.enums.DictTypeEnums;
import com.yunfeiyun.agmp.common.enums.TaskType;
import com.yunfeiyun.agmp.common.utils.DictUtils;
import com.yunfeiyun.agmp.common.utils.StringUtils;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 农事任务对象 FmsTask
 * 
 * @author 杨晓辉
 * @date 2023-05-19
 */
@Data
public class FmsTaskResVo extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 农事任务标识 */
    private String taskId;

    /** 任务编号 */
    private String taskNo;

    /** 种植计划标识 */
    private String planId;

    /** 地块标识 */
    private String blockId;

    /** 基地标识 */
    private String landId;

    /** 作物标识 */
    private String cropId;

    /** 手动自动 */
    private String taskCreatetype;

    /** 农事任务类型 */
    private String taskType;

    /** 农事任务详情 */
    private String taskContent;

    /** 农事任务计划执行日期 */
    private String taskPlanstartdate;

    /** 农事任务计划截止日期 */
    private String taskPlanenddate;

    /** 下发上报记录 */
    private String taskAudittype;

    /** 农事任务审核状态 */
    private String taskStatus;

    /** 农事任务负责人 */
    private String taskManager;

    /** 农事任务负责人姓名 */
    private String taskManagername;

    /** 农事任务创建人 */
    private String taskCreator;

    /** 农事任务创建人姓名 */
    private String taskCreatorName;

    /** 农事任务创建时间 */
    private String taskCreateddate;

    /** 完成时间 */
    private String taskCompletedate;

    /** 农事任务修改时间 */
    private String taskModifieddate;

    /** 农事任务完成原因 */
    private String taskCompletereason;

    /** 作物名称 */
    private String cropName;

    /** 作物种类 */
    private String cropType;

    /** 基地名称 */
    private String landName;

    /** 地块名称 */
    private String blockName;

    /** 计划编号 */
    private String planNo;

    /** 计划面积 */
    private String planArea;


    /** 农事任务类型名称 */
    private String taskTypeContent;

    /** 审核类型名称 */
    private String taskAudittypeContent;

    /** 农事任务审核状态名称 */
    private String taskStatusContent;

    /** 农事任务提交记录标识 */
    private String taskrcdId;

    /** 涉及农资内容 */
    private String goodInfoContent;

    /** 涉及农资内容 */
    private String machInfoContent;

    /** 审核人 */
    private String taskAuditor;

    private BigDecimal taskrcdHour;


    public String getTaskTypeContent() {
        if (!StringUtils.isEmpty(this.taskType)) {
            return DictUtils.getDictLabel(DictTypeEnums.FMS_TASK_WORK_TYPE.getCode(), this.taskType);
        } else {
            return "";
        }
    }

    public String getTaskAudittypeContent() {
        if (!StringUtils.isEmpty(this.taskAudittype)) {
            if (TaskType.PICK.getCode().equals(this.taskAudittype)) {
                return TaskType.PICK.getMessage();
            } else if (TaskType.PATROL.getCode().equals(this.taskAudittype)) {
                return TaskType.PATROL.getMessage();
            } else {
                return DictUtils.getDictLabel(DictTypeEnums.FMS_TASK_AUDIT_TYPE.getCode(), this.taskAudittype);
            }
        } else {
            return "";
        }
    }

    public String getTaskStatusContent() {
        if (!StringUtils.isEmpty(this.taskStatus)) {
            return DictUtils.getDictLabel(DictTypeEnums.FMS_TASK_STATUS.getCode(), this.taskStatus);
        } else {
            return "";
        }
    }
}
